CREATE TABLE canned_responses (
  response_id int(11) NOT NULL auto_increment,
  response_title varchar(25),
  response_text text,
  PRIMARY KEY (response_id)
);

ALTER TABLE forum_group_list ADD COLUMN allow_anonymous INT NOT NULL DEFAULT 0;
ALTER TABLE forum_group_list ADD COLUMN send_all_posts_to text;
ALTER TABLE forum ADD COLUMN most_recent_date INT NOT NULL DEFAULT 0;
UPDATE forum SET most_recent_date=date;

--next index should be used during posting process
create index forum_forumid_isfollowupto on forum(group_forum_id,is_followup_to);
--next index used on ultimate view
create index forum_forumid_isfollto_mostrecentdate on forum(group_forum_id,is_followup_to,most_recent_date);
--next index used on forum summary page, no comments view,threaded,
create index forum_forumid_msgid on forum (group_forum_id,msg_id);
--next index should be used during posting to get master of this thread
create index forum_threadid_isfollowupto on forum(thread_id,is_followup_to);

DROP INDEX idx_forum_is_followup_to ON forum; 
DROP INDEX idx_forum_id_date ON forum; 
DROP INDEX idx_forum_id_date_followup ON forum;
DROP INDEX idx_forum_thread_date_followup ON forum;

--create index forum_group_forum_id on forum (group_forum_id);
--create index forum_thread_id on forum (thread_id);


UPDATE users SET user_name='Nobody',realname='Nobody/Anonymous' WHERE user_id=100;

CREATE TABLE system_news (
id int not null auto_increment primary key,
status_id int not null default 0,
service_id int not null default 0,
machine_id int not null default 0,
priority int not null default 0,
posted_by int not null default 0,
summary text,
details text
);

CREATE TABLE system_history (
id int not null auto_increment primary key,
system_news_id int not null default 0,
field_name text,
old_value text
);

CREATE TABLE system_status (
id int not null auto_increment primary key,
status_name text
);

CREATE TABLE system_services (
id int not null auto_increment primary key,
service_name text
);

CREATE TABLE system_machines (
id int not null auto_increment primary key,
machine_name text,
description text
);


DELETE FROM user_preferences WHERE preference_name='forum_style';
