<?php
//
// SourceForge: Breaking Down the Barriers to Open Source Development
// Copyright 1999-2000 (c) The SourceForge Crew
// http://sourceforge.net
//
// $Id: tos_text.php,v 1.2 2000/09/04 22:14:40 q Exp $
?>

<p>
<h2>SourceForge Terms of Service Agreement</h2>
</p>

<p>
<B>1. ACCEPTANCE OF TERMS</B> 
</p>

<p>
A person's use of SourceForge and any of its Services (as defined below) at
any time is subject to SourceForge's then-current Terms of Service ("TOS"),
which may be updated from time to time as set forth below. Each user can
review the then-current TOS at any time at:
<a href="http://sourceforge.net/tos/tos.php">http://sourceforge.net/tos/tos.php.</a>.  In addition, each user's use of
particular Services may be subject to specific guidelines or rules
("Service-specific Rules") posted from time to time and incorporated by this
reference into the TOS.  A user's use of  SourceForge and/or its Services
constitutes full acceptance of and agreement to the TOS; if a user does not
accept our TOS, he or she is not granted rights to use Sourceforge or any of
its Services, as defined herein, and should refrain from accessing
SourceForge and its Services.
</p>

<p>
To update the TOS or any Service-specific Rules, we will both post the
changed version and its effective date at
<a href="http://sourceforge.net/tos/tos.php">http://sourceforge.net/tos/tos.php</a>.  Concurrently with any change to the
core TOS, we will email notice of the change to known users at least 15 days
(or such shorter or longer time as mandated by law or any judicial or
government body) in advance.  If we change any Service-specific Rules, we
will post the changed version on the location where those Service-specific
Rules normally appear,  reference the change on the primary page for that
Service and include a link to the previous version of the rules.
</p>

<p>
SourceForge reserves the right at any time and from time to time to modify
or discontinue, temporarily or permanently, SourceForge or any Service
thereon (or any part thereof) with notice to users and the public as
described above, or immediately in the event of technical difficulties.
SourceForge shall not be liable to any user or other third party for any
such modification, suspension or discontinuance except as expressly provided
herein.
</p>

<p>
<B>2. DESCRIPTION OF SERVICE; NO WEB ACCESS</B> 
</p>

<p>
SourceForge is a website owned and operated by VA Linux Systems, Inc., for
the purpose of fostering software development and content creation under
Open-Source Initiative ("OSI")-approved licenses or other arrangements
relating to software and/or content development that may be approved by
SourceForge (the "Purpose").  SourceForge currently offers users access to a
rich collection of on-line resources for Open Source  software  development
and content creation, including various  communications tools, source code
control and project management tools, online forums, shopping services,
personalized content and branded programming through its network of
properties (collectively, the "Services").  To use the Services, each user
must independently obtain access to the World Wide Web, either directly or
through devices that access Web-based content, and pay any and all service
fees or equipment costs associated with such access.
</p>

<p>
<B>3. REGISTRATION OBLIGATIONS</B> 
</p>

<p>
If required by the site in question, each user must: (a) provide true,
accurate, current and complete information on the Service's registration
form (collectively, the "Registration Data") and (b) maintain and promptly
update the Registration Data as necessary. If, after investigation, we have
reasonable grounds to suspect that any user's information is untrue,
inaccurate, not current or incomplete, we may suspend or terminate that
user's account and prohibit any and all current or future use of the
Services (or any portion thereof) by that user other than as expressly
provided herein.
</p>

<p>
Each user will receive a password and account designation upon completing
the Service's registration process and is wholly responsible for maintaining
the confidentiality thereof and wholly liable for all activities occurring
thereunder.    SourceForge cannot and will not be liable for any loss or
damage arising from a user's failure to comply with this Section, including
any loss or damage arising from any user's failure to (a) immediately notify
SourceForge of any unauthorized use of his or her password or account or any
other breach of security and (b) ensure that he or she exits from his or her
account at the end of each session.
</p>

<p>
SourceForge handles user Registration Data in accordance with the
SourceForge Privacy Policy accessible at
<a href="http://sourceforge.net/tos/privacy.php">http://sourceforge.net/tos/privacy.php</a>.
</p>

<p>
<B>4. CONTENT</B> 
</p>

<p>
All information, data, text, software, music, sound, photographs, graphics,
video, messages or any other materials whatsoever (collectively, "Content"),
whether publicly posted or privately transmitted, are the sole
responsibility of the person from which such Content originated. This means
that the user, and not SourceForge, is entirely responsible for all Content
that he or she uploads, posts, emails or otherwise transmits via SourceForge
or any Service. No user shall transmit Content or otherwise conduct or
participate in any activities on SourceForge and/or any Service which, in
the opinion of SourceForge's counsel, are prohibited by law in applicable
jurisdictions, including laws governing the encryption of software, the
export of technology, the transmission of obscenity or the permissible uses
of intellectual property.
</p>

<p>
SourceForge will not pre-screen or review Content, but SourceForge reserves
the right to refuse or delete any Content of which it becomes aware which it
reasonably deems not to fulfill the Purpose. In addition, SourceForge shall
have the right (but not the obligation) in its sole discretion to refuse or
delete any Content which it reasonably considers to violate the TOS or be
otherwise illegal.  SourceForge, in its sole and absolute discretion, may
preserve Content and may also disclose Content if required to do so by law
or judicial or governmental mandate or as reasonably determined necessary by
us to protect the rights, property or personal safety of SourceForge, its
users and the public. SourceForge does not control the Content posted via
the Service and, as such, does not guarantee the accuracy, integrity or
quality of such Content. Under no circumstances will SourceForge be liable
in any way for any Content, including, but not limited to, liability for any
errors or omissions in any Content or for any loss or damage of any kind
incurred as a result of the use of any Content posted, emailed or otherwise
transmitted via SourceForge or any Service thereon.
</p>

<p>
Each user, by using SourceForge or any Service, may be exposed to Content
that is offensive, indecent or objectionable.   Each user must evaluate, and
bear all risks associated with, the use of any Content, including any
reliance on the accuracy, completeness, or usefulness of such Content.
</p>

<p>
Licensing and Other Terms Applying to Code and Other Content Posted on
SourceForge:
</p>

<p>
Use, reproduction, modification, and other intellectual property rights to
data stored in CVS or as a file release and posted by any user on
SourceForge ("Source Code") shall be subject to the OSI-approved license
applicable to such Source Code, or to such other licensing arrangements that
may be approved by SourceForge as applicable to such Source Code.
</p>

<p>
With respect to text or data entered into and stored by publicly-accessible
site features such as message boards and bug trackers ("SourceForge Public
Content"), the submitting user retains ownership of such SourceForge Public
Content; with respect to publicly-available statistical content which is
generated by the site to monitor and display project activity, such content
is owned by SourceForge.  In each such case, the submitting user grants
SourceForge the royalty-free, perpetual, irrevocable, non-exclusive and
fully sublicensable right and license to use, reproduce, modify, adapt,
publish, translate, create derivative works from, distribute, perform and
display such Content (in whole or part) worldwide and/or to incorporate it
in other works in any form, media, or technology now known or later
developed, all subject to the terms of any applicable Open Source
Initiative-approved license.
</p>

<p>
With respect to Content posted to private areas of SourceForge, i.e.,
private SourceForge development tools or SourceForge Mail, the submitting
user may grant to SourceForge or other users such rights and licenses as the
submitting user deems appropriate.
</p>

<p>
Content located on any SourceForge-hosted subdomain which is subject to the
sole editorial control of the owner or licensee of such subdomain, shall be
subject to the OSI-approved license applicable to such Source Code, or to
such other licensing arrangements that may be approved by SourceForge as
applicable to such Content.
</p>

<p>
<B>5. NO RESALE OF SERVICE</B> 
</p>

<p>

You agree not to sell, resell or offer for any commercial purposes, any
portion of the Services, use of the Services or access to the Services.
</p>

<p>
<B>6. GENERAL PRACTICES REGARDING USE AND STORAGE</B> 
</p>

<p>
SourceForge may establish general practices and limits concerning use of the
Services, as defined by posted Service-specific Rules.  While SourceForge
will use reasonable efforts to back up site data and make such data
available in the event of loss or deletion, SourceForge has no
responsibility or liability for the deletion or failure to store any
messages and other communications or other Content maintained or transmitted
by any Service. SourceForge reserves the right to mark as "inactive" and
archive accounts and/or projects that are inactive for an extended period of
time. SourceForge reserves the right to change these general practices and
Service-specific Rules at any time, in its sole discretion, with notice to
users and the public as described in Section 1 above.
</p>

<p>
<B>7. TERMINATION</B>
</p>

<p>
A user's account may be terminated for reasons that include, but are not
limited to, the following:  1.) violation of these TOS;  2.) abuse of site
resources or attempt to gain unauthorized entry to the site or site
resources; 3.) use of Service in a manner inconsistent with the Purpose; 4.)
a user's request for such termination; and 5.) requirement of applicable
law, regulation, court or governing agency order.
</p>

<p>
SourceForge's termination of any user's access to SourceForge or any Service
hereunder may be effected without notice and, on such termination,
SourceForge may immediately deactivate or delete user's account and/or bar
any further access to such files, that Service or SourceForge.  SourceForge
shall not be liable to any user or other third party for any termination of
that user's access or account hereunder.
</p>

<p>
Notwithstanding the foregoing, unless prohibited by law or judicial or
governmental order, SourceForge shall make reasonable efforts to make
available all information in a user's account to that user prior to deleting
that account or marking that account "inactive", including emailing to the
affected user 15-days prior notice of such termination and the location of
such user's information, and retaining all information for at least 15 days
after  emailing such notice..
</p>

<p>
<B>8. LINKS</B>
</p>

<p>
SourceForge, any Service or a third party may provide links to other
Websites.  SourceForge exercises no control whatsoever over such other
Websites and Web-based resources and is not responsible or liable for the
availability thereof or the Content, advertising, products or other
materials thereon. SourceForge shall not be responsible or liable, directly
or indirectly, for any damage or loss incurred or suffered by any user in
connection therewith.
</p>

<p>
<B>9. INDEMNITY; DISCLAIMER OF WARRANTIES; LIMITATION OF LIABILITY</B> 
</p>

<p>
Each user shall indemnify, defend and hold harmless each of VA Linux
Systems, Inc. and its affiliates and their respective officers, employees
and agents, and any of VA Linux System's  website partners from any and all
claims or demands, including reasonable attorneys' fees, made by any third
party due to or arising out of that user's acts or omissions, including
claims arising out of that user's use of SourceForge; his or her submission,
posting or transmission of Content or his or her violation of the TOS.

EACH USER'S USE OF THE SERVICE IS AT HIS OR HER SOLE RISK. THE SERVICE IS
PROVIDED ON AN "AS IS" AND "AS AVAILABLE" BASIS AND SOURCEFORGE ASSUMES NO
RESPONSIBILITY FOR THE TIMELINESS, DELETION, MIS-DELIVERY OR FAILURE TO
STORE ANY USER COMMUNICATIONS OR PERSONALIZATION SETTINGS.  EACH USER WILL
BE SOLELY RESPONSIBLE FOR ANY DAMAGE TO HIS OR HER COMPUTER SYSTEM OR LOSS
OF DATA WHICH RESULTS FROM THE DOWNLOAD OF ANY SUCH MATERIAL.  SOURCEFORGE
EXPRESSLY DISCLAIMS ALL WARRANTIES OF ANY KIND, WHETHER EXPRESS OR IMPLIED,
INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.  SPECIFICALLY,
SOURCEFORGE MAKES NO WARRANTY THAT (i) SOURCEFORGE OR ANY SERVICE WILL MEET
YOUR REQUIREMENTS, (ii) ANY USER ACCESS WILL BE UNINTERRUPTED, TIMELY,
SECURE OR ERROR-FREE, (iii) THE QUALITY OF ANY CONTENT, PRODUCTS, SERVICES,
INFORMATION OR OTHER MATERIAL OBTAINED BY ANY USER WILL MEET HIS OR HER
EXPECTATIONS, AND (iv) ANY ERRORS IN THE SOFTWARE WILL BE CORRECTED.

EXCLUDING ONLY DAMAGES ARISING OUT OF VA LINUX SYSTEMS' GROSS NEGLIGENCE OR
WILLFUL MISCONDUCT, VA LINUX SYSTEMS, INC. SHALL NOT BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, CONSEQUENTIAL OR EXEMPLARY DAMAGES,
INCLUDING BUT NOT LIMITED TO DAMAGES FOR LOSS OF PROFITS, GOODWILL, USE,
DATA OR OTHER INTANGIBLE LOSSES (EVEN IF VA LINUX SYSTEMS HAS BEEN ADVISED
OF THE POSSIBILITY OF SUCH DAMAGES), RESULTING FROM ANY USER'S USE OR
INABILITY TO USE THE SERVICE; THE COST OF PROCUREMENT OF SUBSTITUTE
SERVICES; UNAUTHORIZED ACCESS TO OR ALTERATION OF YOUR TRANSMISSIONS OR
DATA; STATEMENTS OR CONDUCT OF ANY THIRD PARTY ON THE SERVICE; OR ANY OTHER
MATTER RELATING TO SOURCEFORGE OR ANY SERVICE.  IN NO EVENT SHALL VA LINUX
SYSTEMS' TOTAL CUMULATIVE LIABILITY TO ANY USER OR OTHER PARTY UNDER THESE
TERMS OF SERVICE OR OTHERWISE EXCEED $1,000.00.

SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF CERTAIN WARRANTIES OR THE
LIMITATION OR EXCLUSION OF LIABILITY FOR INCIDENTAL OR CONSEQUENTIAL
DAMAGES. ACCORDINGLY, SOME OF THE ABOVE LIMITATIONS MAY NOT APPLY TO YOU.

NOTHING HEREIN SHALL BE DEEMED TO CREATE AN AGENCY, PARTNERSHIP, JOINT
VENTURE, EMPLOYEE-EMPLOYER OR FRANCHISOR-FRANCHISEE RELATIONSHIP OF ANY KIND
BETWEEN VA LINUX SYSTEMS AND ANY USER OR OTHER PERSON OR ENTITY NOR DO THESE
TERMS OF SERVICE EXTEND RIGHTS TO ANY THIRD PARTY.  AS NOTED ABOVE, VA LINUX
SYSTEMS DOES NOT AND CANNOT CONTROL THE ACTIONS OF SOURCEFORGE USERS,
VISITORS OR LINKED THIRD PARTIES.  WE RESERVE THE RIGHT TO REPORT ANY
MALFEASANCE WHICH COMES TO OUR ATTENTION TO THE APPROPRIATE AUTHORITIES.
WE DO NOT GUARANTEE CONTINUOUS UNINTERRUPTED OR SECURE ACCESS TO SOURCEFORGE
OR ANY SERVICES.  OPERATION OF THE WEBSITE MAY BE SUBJECT TO INTERFERENCE
FROM NUMEROUS FACTORS OUTSIDE OUR CONTROL.  FURTHER, SCHEDULED AND
PREVENTIVE MAINTENANCE AS WELL AS REQUIRED AND EMERGENCY MAINTENANCE WORK
MAY TEMPORARILY INTERRUPT SERVICES OR ACCESS TO THE WEBSITE. THE DISCLAIMERS
OF WARRANTY AND LIMITATIONS OF LIABILITY APPLY, WITHOUT LIMITATION, TO ANY
DAMAGES OR INJURY CAUSED BY THE FAILURE OF PERFORMANCE, ERROR, OMISSION,
INTERRUPTION, DELETION, DEFECT, DELAY IN OPERATION OR TRANSMISSION, COMPUTER
VIRUS, COMMUNICATION LINE FAILURE, THEFT OR DESTRUCTION OR UNAUTHORIZED
ACCESS TO, ALTERATION OF OR USE OF ANY ASSET, WHETHER ARISING OUT OF BREACH
OF CONTRACT, TORTIOUS BEHAVIOUR, NEGLIGENCE OR ANY OTHER COURSE OF ACTION BY
VA LINUX SYSTEMS, INC.
</p>

<p>
<b>10. TRADEMARK INFORMATION</b>
</p>

<p>
SourceForge, the SourceForge logo and other SourceForge trademarks, service
marks, and product and service names are trademarks of VA Linux Systems Inc.
(the "SourceForge Marks").  VA Linux Systems is a trademark of VA Linux
Systems, Inc. Linux is a registered trademark of Linus Torvalds.  All other
marks are property of their respective owners.  Users may display or use the
SourceForge Marks in only in accordance with VA's Trademark Use Guidelines.
</p>

<p>
<b>11. COPYRIGHTS</b>
</p>

<p>
SourceForge respects the intellectual property of all parties and we ask our
users to do the same.  If a user  or other third party believes that its
Content has been copied in a way that constitutes copyright infringement,
that user or third party should provide SourceForge with the following
information:  (a) an electronic or physical signature of the person
authorized to act on behalf of the owner of the copyright interest; (b) a
description of the copyrighted work that has been infringed; (c) a
description of where the allegedly infringing material is located on the
Website; (d) the affected user or third party's  address, telephone number
and email address; (e) a statement by the affected user or third party that
he or she has a good faith belief that the disputed use is not authorized by
the copyright  owner, its agent or the law; and (f) a statement by the
affected user or third party, under penalty of perjury, that the above
information is accurate and that such user or third party is the copyright
owner or is otherwise authorized to act on the copyright owner's behalf.  If
SourceForge receives such a claim, SourceForge reserves the right to refuse
or delete Content as described under Section 4 hereto, or to terminate a
user's account in accordance with Section 7.
</p>

<p>
<b>12. GENERAL INFORMATION</b>
</p>

<p>
The TOS constitute the entire agreement between each user and VA Linux
Systems, Inc. and govern each user's use of the Service, superceding any
prior agreements. Each user may be subject to additional terms and
conditions that may apply when that user uses affiliate services, third
party content or third party software. The TOS and the relationship between
each user and VA Linux Systems shall be governed by the laws of the State of
California without regard to its conflict of law provisions and each party
shall submit to the personal and exclusive jurisdiction of the courts
located within the county of Santa Clara, California. If any provision of
the TOS is found by a court of competent jurisdiction to be invalid, the
parties nevertheless agree that the court should endeavor to give effect to
the parties' intentions as reflected in the provision, and the other
provisions of the TOS remain in full force and effect.
</p>

<p>
<b>13. VIOLATIONS</b>
</p>

<p>
Please report any violations of the TOS, any alleged copyright infringements
or any other matters to the SourceForge Support Manager at
staff@sourceforge.net.
</p>

<p>
VA Linux Systems and SourceForge are trademarks of VA Linux Systems, Inc.
Linux is a registered trademark of Linus Torvalds.  All other trademarks and
copyrights on this page are property of their respective owners.   For
information about other Content of this page, please see the Terms of
Service governing usage of this site at <a href="http://sourceforge.net/tos/tos.php">http://sourceforge.net/tos/tos.php</a>.
For SourceForge privacy policy information, please see
<a href="http://sourceforge.net/tos/privacy.php">http://sourceforge.net/tos/privacy.php</a>. Content owned by VA Linux Systems is
copyright 1999-2000 VA Linux Systems, Inc.  All rights reserved.
</p>

